#/usr/bin/python3
# -*- coding: utf-8 -*-
#
# System-config-pam tools access entry dialog
#
# This file contains the access entry dialog user interface
#
#  Author: MengYuan <mengyuan@kylinos.cn>
#
#  Copyright (C) 2017,Tianjin KYLIN Information Technology Co., Ltd.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this program; if not, write to the
#  Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
#  Boston, MA 02110-1301, USA.

import sys

from PyQt5.QtWidgets import QDialog,QCheckBox,QVBoxLayout
from PyQt5.QtWidgets import QApplication,QDialogButtonBox

from ui_accessentrydialog import Ui_AccessEntryDialog


class AccessEntryDialog(QDialog):
    def __init__(self, parent = None):
        QDialog.__init__(self, parent)
        self.ui = Ui_AccessEntryDialog()
        self.ui.setupUi(self)
        self.ui.buttonBox.accepted.connect(self.onAcceptButtonClicked)
        self.ui.pushButton.clicked.connect(self.onConfigttyButtonClicked)

    def onAcceptButtonClicked(self):
        pass

    def onConfigttyButtonClicked(self):
        dialog = QDialog(self)
        dialog.resize(200,300)
        dialog.setWindowTitle("控制台登陆配置")
        layout = QVBoxLayout(dialog)
        c1 = QCheckBox("tty1")
        layout.addWidget(c1)
        c2 = QCheckBox("tty2")
        layout.addWidget(c2)
        c3 = QCheckBox("tty3")
        layout.addWidget(c3)
        c4 = QCheckBox("tty4")
        layout.addWidget(c4)
        c5 = QCheckBox("tty5")
        layout.addWidget(c5)
        c6 = QCheckBox("tty6")
        layout.addWidget(c6)
        c7 = QDialogButtonBox(QDialogButtonBox.Cancel|QDialogButtonBox.Ok)
        layout.addWidget(c7)
        dialog.exec_()

if __name__ == "__main__":
    app = QApplication(sys.argv)
    dialog = AccessEntryDialog()
    dialog.show()
    app.exec_()
        
