#!/usr/bin/python3
# -*- coding: utf-8 -*-
#
#  System-config-pam login info interfaces
#
#  This file provides methods to get and set login information after
#  user login successfully
#
#  Author: MengYuan <mengyuan@kylinos.cn>
#
#  Copyright (C) 2017,Tianjin KYLIN Information Technology Co., Ltd.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this program; if not, write to the
#  Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
#  Boston, MA 02110-1301, USA.

import shutil

LOGIN_CONF = "/etc/pam.d/login"
LOGIN_CONF_BAK = "/etc/pam.d/.login"
lastlogconf = "session\toptional\tpam_lastlog.so\t"
login_msg = {   "lastlog": 0,
                "showfailed":0
               # "pam_echo":0,
               # "msg":""
	}


def get_login_info():
    ret = login_msg
    t = []
    try:
        fp = open(LOGIN_CONF, 'r')
    except IOError as e:
        print("Cannot read login config", e)
        return
    else:
        tmp = fp.readlines()
        fp.close()

    for i in tmp:
        if i.strip().startswith('#'):
            continue
        elif i.strip().startswith("session") and "lastlog" in i and "pam_echo" not in i:
            if "showfailed" in i:
                ret["showfailed"] = 1
            if "silent" not in i:
                ret["lastlog"] = 1
        else:
            continue
    
    '''
        if "pam_echo" in i:
            if i.split()[3].startswith("file="):
                ret["pam_echo"] = 1
                x = i.split()[3].split("=")[1]
                if exists(x):
                    ret["msg"] = x
                else:
                    ret["msg"] = "file not exists"
            else :
                ret["pam_echo"] = 2
                ret["msg"] = i[i.find("echo.so") + 7:].lstrip()
    '''
    return ret

def set_login_info(issue):
    try:
        shutil.copyfile(LOGIN_CONF,LOGIN_CONF_BAK)
    except IOError as e:
        print("Cannot bakup login config", e)
    
    try:
        f = open(LOGIN_CONF,"r")
    except IOError as e:
        print("Cannot read login config", e)
        raise e
    else:
        tmp = f.readlines()
        f.close()

    t = []
    for i in tmp:
        if i.strip().startswith("session") and "lastlog" in i and "pam_echo" not in i:
            continue
        else:
            t.append(i)

    if issue["lastlog"] == 0 and issue["showfailed"] == 1:
        t.append(lastlogconf+"showfailed silent\n")
    if issue["lastlog"] == 1 and issue["showfailed"] == 1:
        t.append(lastlogconf+"showfailed\n")
    if issue["lastlog"] == 1 and issue["showfailed"] == 0:
        t.append(lastlogconf+"\n")
    if issue["lastlog"] == 0 and issue["showfailed"] == 0:
        t.append(lastlogconf+"silent\n")

    try:
        fp = open(LOGIN_CONF,"w")
    except IOError as e:
        print("Cannot write login config" , e)
        raise e
    else:
        fp.writelines(t)
        fp.close()

