#!/usr/bin/python3
# -*- coding: utf-8 -*-
#
#  Utils for system-config-pam
#
#  This file contains some utils used in system-config-pam
#
#  Authors: SongChuanfei <songchuanfei@kylinos.cn>
#           MengYuan <mengyuan@kylinos.cn>
#
#  Copyright (C) 2017,Tianjin KYLIN Information Technology Co., Ltd.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this program; if not, write to the
#  Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
#  Boston, MA 02110-1301, USA.

import ctypes

def isPlainFile(filepath):
    cookie = magic.open(magic.MIME_TYPE)
    
    #cookie.load("/usr/share/misc/magic.mgc")
    cookie.load(ctypes.c_char_p("/usr/share/misc/magic.mgc".encode("utf-8")))
    encoding = cookie.file(filepath)
    cookie.close()

    return encoding == "text/plain"

def handle_int_option(string):
    try:
        return int(string)
    except ValueError as e:
        print("Get Invalid Options",e)
        return 0
